#include "Barrier.h"

void Barrier::wait() 
{
	bool release = false;

	int res = pthread_mutex_lock(pMutex);

	if(res == 0) 
	{	
		if (nowReleasing) 
			pthread_cond_wait(pCond, pMutex);

		noSleepers++;

		if (noSleepers == noThreads)
		{
			nowReleasing = true;

			release = true;
		}
		else
		{
			while (not nowReleasing)
				pthread_cond_wait(pCond, pMutex);
		}

		noSleepers--;


		if (noSleepers == 0)
		{
			nowReleasing = false;
			release = true;
		}

	}

	pthread_mutex_unlock(pMutex);

	if (release) 
		pthread_cond_broadcast(pCond);
}

Barrier::Barrier(size_t nthreads) : noThreads(nthreads), noSleepers(0), nowReleasing(false)
{
	pMutex = new pthread_mutex_t; 
	pCond = new pthread_cond_t;
}

Barrier::~Barrier()
{
	if (pMutex) 
	{
		delete pMutex;
		pMutex = NULL;
	} 

	if (pCond)
	{
		delete pCond;
		pCond = NULL;
	}
}
