//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//      Filename                :               Barrier.h                               //
//                                                                                      //
//      Author                  :               Raman Dhillon                           //
//                                                                                      //
//      Version                 :               1.0                                     //
//                                                                                      //
//      Location                :               Pervasive Communication Lab             //
//                                              University of Colorado at Boulder       //
//                                                                                      //
//      Change Log                                                                      //
//      --------------------------------------------------------------------------      //
//      Change          Author          Date            Reason                          //
//                                                                                      //
//      --------------------------------------------------------------------------      //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////


#ifndef _BARRIER_H
#define _BARRIER_H

#include <pthread.h>
#include <cstddef>
#include <iostream>

using namespace std;

class Barrier
{

	pthread_mutex_t* pMutex;
	pthread_cond_t * pCond;

	size_t noThreads;
	size_t noSleepers;
	bool nowReleasing;
  public:
	Barrier(size_t nthreads);
	~Barrier();
	void wait();
}; 

#endif
